
# 1 帐号注册接口

### 注册请求
- URI
	
        /he/register		POST

- 参数

        参数以 form 表单的形式提交.
| 字段       |   字段名称       |   类型    |   长度  |  必须有值  |  必传 |
|:----------|:----------------|:---------|:-------|:----------|:-----| 
| email     | 企业邮箱         | string   | 6 ~ 32 |     Y     |    Y |
| phone     | 手机号码         | string   | 6 ~ 32 |     Y     |    Y |
| sms_code  | 手机验证码       | string   | 4 ~ 6  |     Y     |    Y |
| pass      | 密码(MD5)       | string   | 32     |     Y     |    Y |

### 注册响应

- 状态码

        200    注册操作成功.
        500    参数不合要求 或 注册出现异常

- 注册成功, 返回用户手机号码

        {
            "data": 18818869897,    // 手机号码
            "msg": "",
            "code": 200
        }

- 注册不成功, 提示异常信息给用户查看

        {
            "data": null,
            "msg": "增加用户资料步骤出错了",
            "code": 500
        }
        
---

# 2 登录接口

### 登录请求
- URI
	
    	  /he/jss_login_check 	POST
	
- 参数

         参数以 form 表单的形式提交.
| 字段       |   字段名称       |   类型    |   长度  |  必须有值  |  必传 |
|:----------|:----------------|:---------|:-------|:----------|:-----| 
| username  | 用户帐号 或 手机号 | string   | 6 ~ 32 |     Y     |    Y |
| password  |    密码          | string   | 32     |     Y     |    Y |
    
    #### 登录方式现在有两种
    #####一. 用户帐号 + 密码 登录方式
           
    >	提交到 Server 端之前帐号和密码都需要做如下的变动:
    
    >- 帐号值变动
    
    >         $("#username").val("account"+username);
      	
    >- 密码值变动:	(此处采用的username的值是未变动的.)
        
    >    	  var pmd5 = $.md5(password);	
    >    	  $("#password").val($.md5(username+pmd5));    
    >      
    
    ##### 二. 手机号 + 验证码 快捷登录方式
    1 . 手机验证码请求
    
    >- URI
    
    >    	  /he/n/send_sms
    
    >- 参数
    
    >         手机号检验通过,才会发送验证码到手机
    | 字段       |   字段名称       |   类型    |   长度  |  必须有值  |  必传 |
    |:----------|:----------------|:---------|:-------|:----------|:-----| 
    | phone     |  手机号          | string   | 11     |     Y     |    Y |
    
    2 . 提交到 Server 端之前帐号和密码都需要做如下的变动:

    >- 帐号值变动: 
    
    >         $("#username").val("sms"+username);
    	
    >- 密码值变动 	(此处采用的 `username` 的值是未变动的; `smsCode` 是用户填写的验证码值)
    
    >         $("#password").val($.md5(username+smsCode));


### 登录响应

- 登录失败
```
    {
        "data": null,
        "msg": "未通过登录检查",
        "code": 500
    }
```

- 登录成功.

> 1. 设置了用户名称到Session , 属性值: ` username ` .
> 2. 设置了此用户可访问的菜单列表 `List<AccessMenu> ` , Session属性值: ` user_menu_session ` .
    - 数据结构:
>
            List<AccessMenu>
>
               其中 AccessMenu:
                           String desc;
                           List<AccessModule> moduleList;
                           List<AccessMenu> subMenuList; // 子菜单列表     
>
                    其中 AccessModule:
                           String desc;
                           String uri;
    - 数据范例 
>
            [{
                "desc": "系统基本配置",
                "moduleList": [{
                    "desc": "权限基础数据",
                    "uri": "/he/privilege/manager"
                },
                {
                    "desc": "角色管理配置",
                    "uri": "/he/privilege_role/manager"
                },
                {
                    "desc": "用户管理配置",
                    "uri": "/he/privilege_user/manager"
                }],
                "subMenuList": [{
                    "desc": "测试2",
                    "moduleList": [{
                        "desc": "用户管理",
                        "uri": "/he/user/manager"
                    }],
                    "subMenuList": []
                }]
            },
            {
                "desc": "测试",
                "moduleList": [{
                    "desc": "用户管理配置",
                    "uri": "/he/privilege_user/manager"
                }],
                "subMenuList": []
            }]




---
# 3. 忘记密码（更换密码）

---

# 4. 修改密码


---
# 5. 更换邮箱



---
# 6. 更换手机号码



---

<script src="md.js"></script>