# 1 城市方案列表
- 显示城市的基础配置数据和城市方案数据结合计算的结果.
- 默认显示是第一个城市的方案详情.

### 1.1 请求数据
##### URI

- 带城市方案数据的基础数据明细.
        
        /he/city_plan/list     GET / POST

- 基础配置数据明细.
    
        /he/city_plan/list/default     GET / POST
    
##### 请求参数

    Integer city_code    // 城市代码. 可空.
    
### 1.2 响应

- 响应数据包含 城市方案列表对应的 城市信息列表
- 城市方案数据
- 城市五险一金基础配置数据
- 最高和最低价格数据
- 操作规则常量数据

##### data字段

| 字段                       |    类型          |  字段名称        |
|:--------------------------|:-----------------|:---------------|  
| cityList                  | CityBaseVO       | 城市信息列表  
| city_code                 | int              |  城市代码  
| [plan](t/wxyj.html#TWxyjPlan) | TWxyjPlan    | 城市方案数据  
| shebao               | List(ShebaoTopLowVO) | 社保基础数据  和户籍的最高最低数据.
| [fund](t/wxyj.html#TBaseFund) | TBaseFund    | 城市的公积金基础数据  
| fundTopLow                | List<TopLowItemVO> | 公积金最高最低数据  
| [opt_rules](common.html#opt) | ENUM          | 操作规则枚举常量

- ShebaoTopLowVO

         TBaseShebao shebao;
         List<HukouTopLowVO> topLowList;         
                -- HukouTopLowVO:
                     List<HuKouConst> hukouList; // 相同配置的户口列表
                	 TopLowVO top; // 险种数据
                	 TopLowVO low; // 险种数据            	 
                         ---- TopLowVO:
                             List<TopLowItemVO> itemList; // 险种数据	 
                                ----TopLowItemVO:
                                	String item;		// 险种
                                	double radix;		// 缴费基数
                                	double ent_ratio;	// 单位缴费比例
                                	double ent_amount;	// 单位缴费金额(元)
                                	double p_ratio;		// 个人缴费比例
                                	double p_amount;	// 个人缴费金额(元)
                                	double ratio;		// 合计比例
                                	double amount;		// 合计金额(元)
                                	boolean usePlan;	// 使用了城市方案的配置
                        	 double ent_total; // 单位合计
                        	 double p_total; // 个人合计
                        	 double total; // 合计

    

##### 响应数据示例

暂无 , 后面补充.

---
# 2 指定城市的方案数据
- planId 的 < 1时, 是新增城市方案页面效果.
- 大于 0 时, 是修改页面.

### 2.1 请求数据
##### URI
    
    /he/city_plan/edit/load     GET / POST
    
##### 请求参数

    Integer planId    // 城市方案的标识ID. 可空.
    
### 2.2 响应
- planId 值==0时, 其它字段是空的, 未传.
- planId 值大于0, 其它字段有有效值.

##### data字段

| 字段                       |    类型          |  字段名称        |
|:--------------------------|:-----------------|:---------------|  
| citys                     | List(Map)        | 所有城市. `planId==0` 时才存在.  
| planId                    | int              | 城市方案的标识ID  
| city_name                 | String           |  城市中文名称  
| [plan](t/wxyj.html#TWxyjPlan) | TWxyjPlan    | 城市方案数据


##### 响应数据示例

暂无 , 后面补充.

---
# 3 保存城市的方案数据
- 提交编辑的数据到服务器端保存.

### 3.1 请求数据
##### URI
    
    /he/city_plan/edit     POST
    
##### Params

参数是TWxyjPlan对象的字段列表.

| 字段                       |    类型          |  字段名称        |
|:--------------------------|:-----------------|:---------------| 
| [plan](t/wxyj.html#TWxyjPlan) | TWxyjPlan    | 城市方案数据
    
### 3.2 响应
返回城市方案的标识ID.

##### 状态码

    200    修改成功.
    600    参数异常
   

##### 响应数据示例

    {
        "data": 60,
        "msg": "",
        "code": 200
    }

---
<script src="md.js"></script>