
# 1 员工方案列表

- 列表数据的员工基本信息来自 `员工表` , 不管用户是否配置了方案.
- 方案数据来自 `员工方案表`, 配置员工方案数据主要是操作 `员工方案表` 的数据.

### 方案列表请求

- 列表URI

        /he/shebao_plan/list        GET / POST
    
- 列表查询参数

        提交参数采用 Form 表单 或 JSON 的格式.
| 字段                 | 字段名称     |   类型    |    长度    |  必须有值  | 必传  |
|:--------------------|:------------|:---------|:----------|:-------|:-----| 
|[curr](common.html#page)| 当前页码   | int      | 1 ~ 1000  |       |       |
| user_name              | 员工姓名   | string   | 0 ~ 16    |       |       |

### 方案列表响应

- data字段
    
    | 字段                               |    类型   |  字段名称        |
    |:----------------------------------|:----------|:---------------| 
    | [planList](#spl_planList)         | List      | 员工方案列表的数据 |
    | [cityDayList](#spl_cityDayList)   | List      | 城市数据和参保月数据 |
    | [page](common.html#page)        | Object    | 见通用文档     |
    | user_name                         | String    | 列表查询参数 |
    | [hukous](common.html#hukou)       | Array     | 见通用文档 |
    
    <div id="spl_planList"></div> 
    - 字段 planList
    
            List
                TWxyjEmployeePlan plan;        // 员工方案列表的数据
                        /** 员工方案表的ID */
                    	int id;
                    	/** 企业员工的标识 */
                    	int company_userid;
                    	/** 城市的代码 */
                    	int city_code;
                    	/** 基础参保方案标识 */
                    	int param_id;
                    	/** 企业标识 */
                    	int ent_id;
                    	/** 户藉标识 */
                    	int hukou;
                    	/** 基数的方案    1:自定义  2:最低工资   3:实际工资(暂不支持) */
                    	int radix_type;
                    	/** 社保基数 */
                    	double shebao_radix;
                    	/** 社保调基时间 */
                    	String shebao_uptime;
                    	/** 是否参保社保 */
                    	 int shebao_buy;
                    	/** 是否参缴公积金 */
                    	int fund_buy;
                    	/** 公积金基数 */
                    	double fund_radix;
                    	/** 公积金企业比例 */
                    	double fund_eratio;
                    	/** 积金个人比例 */
                    	double fund_pratio;
                    	/**  */
                    	String update_time;
                    	
            	String city_name;               // 城市名称
            	String shebao_name;            // 社保方案名称
            	String hukou_name;            // 户藉名称
            	int user_id;                  // 员工表的ID
            	String user_name;            // 员工姓名
            	String id_card;            // 员工身份证号码
            	String nation;        // 民族
            	String phone;        // 手机号
            	int gender;        // 性别     0:女  1:男
            	int ustatus;        // 员工状态.
     
    <div id="spl_cityDayList"></div> 
       - 字段 cityDayList
        
            int city_code;           城市代码
        	String city_name;        城市名称
        	int dec_day;             城市方案的减员日期
    
   
    
- 员工方案列表的数据示例

        {
        	"code": 200,
        	"msg": "",
        	"data": {
        		"cityDayList": [{
        			"city_code": 1001,
        			"city_name": "广州",
        			"dec_day": 14
        		},
        		{
        			"city_code": 1014,
        			"city_name": "深圳",
        			"dec_day": 14
        		},
        		{
        			"city_code": 1101,
        			"city_name": "北京",
        			"dec_day": 12
        		}],
        		"hukous": ["LOCAL_CITY",
        			"LOCAL_VILLAGE",
        			"NONLOCAL_CITY",
        			"NONLOCAL_VILLAGE"],
        		"user_name": "",
        		"planList": [{
        			"plan": {
        				"id": 1,
        				"company_userid": 1,
        				"city_code": 1001,
        				"param_id": 1,
        				"ent_id": 1,
        				"hukou": 1,
        				"radix_type": 2,
        				"shebao_radix": 0.0,
        				"shebao_uptime": "2018-03-28",
        				"shebao_buy": 1,
        				"fund_buy": 1,
        				"fund_radix": 15000.0,
        				"fund_eratio": 5.0,
        				"fund_pratio": 12.0,
        				"update_time": "2018-04-09 16:15"
        			},
        			"city_name": "广州",
        			"shebao_name": "标准",
        			"hukou_name": "本市城镇",
        			"user_id": 1,
        			"user_name": "赖先生",
        			"id_card": "123456789012345678",
        			"nation": "汉",
        			"phone": "12345678901",
        			"gender": 1,
        			"ustatus": 1
        		},
        		{
        			"plan": {
        				"id": 2,
        				"company_userid": 2,
        				"city_code": 1014,
        				"param_id": 18,
        				"ent_id": 1,
        				"hukou": 2,
        				"radix_type": 1,
        				"shebao_radix": 1989.0,
        				"shebao_uptime": "2018-03-28",
        				"shebao_buy": 0,
        				"fund_buy": 1,
        				"fund_radix": 15000.0,
        				"fund_eratio": 8.0,
        				"fund_pratio": 12.0,
        				"update_time": "2018-03-28 14:56"
        			},
        			"city_name": "深圳",
        			"shebao_name": "二档",
        			"hukou_name": "本市农村",
        			"user_id": 2,
        			"user_name": "刘小姐",
        			"id_card": "123456789012345681",
        			"nation": "汉",
        			"phone": "12345678901",
        			"gender": 0,
        			"ustatus": 1
        		}],
        		"page": {
        			"size": 2,
        			"first": 1,
        			"curr": 1,
        			"last": 2,
        			"total": 4,
        			"start": 0,
        			"finish": 2
        		}
        	}
        }

---

# 2 查看指定用户的参保方案
> 由于列表的数据是由员工表的数据列出, 所以存在员工没有配置方案的情况, 此时 planId 值传 0, company_userid 需要有效值 <br>
> 有参保方案的员工, 查看时需要 planId 的有效值.

### 查看请求

##### URI

    /he/shebao_plan/view      POST
##### 参数

    int planId                方案的ID
    int company_userid        员工的ID

### 查看响应
##### 响应的代码

    200    成功查询数据
    600    参数有错.

##### 响应的数据结构

- data的主要字段

    | 字段                               |    类型    |  字段名称        |
    |:----------------------------------|:----------|:---------------| 
    | [hukous](common.html#hukou)       | Array     | 见通用文档 
    | [plan](#spl_planList)             | Object    | 方案数据 
    | user                              | Object    | 用户参保相关的数据 
    |[cityDayList](#spl_cityDayList)    | List      | 员工所属企业的城市方案列表  
    | city_params                       | List      | 城市的社保参数基本信息 
    
- 子字段 user
      
		int user_id             员工的ID
		String user_name        员工的姓名
		String id_card          身份证号码
		String nation           民族
		String phone            手机号
		boolean gender          性别: 男:true  女:false

- 子字段 city_params

        String city_name        城市名称
        int city_code           城市代码
        int param_id            社保配置数据的ID
        String shebao_name      社保配置数据的名称


##### 响应的数据示例

    {
    	"msg": "",
    	"code": 200,
    	"data": {
    		"city_params": [{
    			"city_name": "广州",
    			"city_code": 1001,
    			"param_id": 1,
    			"shebao_name": "标准"
    		}],
    		"cityDayList": [{
    			"city_code": 1001,
    			"city_name": "广州",
    			"dec_day": 14
    		},
    		{
    			"city_code": 1014,
    			"city_name": "深圳",
    			"dec_day": 14
    		},
    		{
    			"city_code": 1101,
    			"city_name": "北京",
    			"dec_day": 12
    		}],
    		"hukous": ["LOCAL_CITY",
    			"LOCAL_VILLAGE",
    			"NONLOCAL_CITY",
    			"NONLOCAL_VILLAGE"],
    		"plan": {
    			"id": 1,
    			"company_userid": 1,
    			"city_code": 1001,
    			"param_id": 1,
    			"ent_id": 1,
    			"hukou": 1,
    			"radix_type": 2,
    			"shebao_radix": 0.0,
    			"shebao_uptime": "2018-03-28",
    			"shebao_buy": 1,
    			"fund_buy": 1,
    			"fund_radix": 15000.0,
    			"fund_eratio": 5.0,
    			"fund_pratio": 12.0,
    			"update_time": "2018-04-09 16:15"
    		},
    		"user": {
    			"user_id": 1,
    			"user_name": "赖先生",
    			"id_card": "123456789012345678",
    			"nation": "汉",
    			"phone": "12345678901",
    			"gender": true
    		}
    	}
    }
    
---

# 3 修改用户的参保方案

### 3.1 请求修改
社保, 公积金一起提交过来做修改更新.

- URI

        /he/shebao_plan/edit     POST

- 参数 (以下参数都是必传)
    
    ```java
        /** 企业员工方案标识 */
        int plan_id;
        /** 企业员工的标识 */
        int company_userid;
        /** 城市的代码 */
        int city_code;
        /** 基础参保方案标识 */
        int param_id;
        /** 户藉标识 */
        int hukou;
        /** 基数的方案 */
        int radix_type;
        /** 社保基数 */
        double shebao_radix;
        /** 社保调基时间 */
        String shebao_uptime;
        /** 是否参保社保 */
        int shebao_buy;
        /** 是否参缴公积金 */
        int fund_buy;
        /** 公积金基数 */
        double fund_radix;
        /** 公积金企业比例 */
        double fund_eratio;
        /** 积金个人比例 */
        double fund_pratio;
    ```

### 3.2 响应修改

修改成功返回 plan_id 的值.

1. 修改前进行参数校验; 
2. **plan_id无值**: 则根据身份证查找数据记录,如果存在, 响应异常信息. 如果未存在,则新增此参保方案.
3. **plan_id有值**: 进行数据判断是否存在, 不存在会提示异常信息.

- 状态码
            
        200    修改成功.
        500    参数检查 及 数据存在与否检查 提示.
        
- 响应数据
    
     - 有异常
            
            {
                "data": null,
                "msg": "员工的五险一金方案不存在，已经终止修改。",
                "code": 500
            }
            
     - 成功修改
    
        ```json
        {
            "data": 60,
            "msg": "",
            "code": 200
        }
        ```
        
---

# 4 快捷设置状态

### 4.1 请求修改
社保, 公积金的参缴状态快速配置

- URI

        /he/shebao_plan/edit/status     POST

- 参数 (以下参数都是必传)

        Integer status        // 1: 开启参缴    0: 不参缴
        Integer wxyj          // 1: 社保        2: 公积金
        String user_ids       // 员工ID列表, 逗号间隔

### 4.2 响应
返回修改成功的数量.

    {
        "data": 10,    // 成功修改10个员工的参缴状态.
        "msg": "",
        "code": 200
    }

---

<script src="md.js"></script>